$adapter="AGATCGGAAGAGCACACGTCT";
$min_adapter_length=8;
$min_sequence_length=0;

@input=
	(
	"1_Bovine_GV_a_ATCACG.fasta",
	"2_Bovine_GV_b1_CGATGT.fasta",
	"4_Bovine_MI_1_TGACCA.fasta",
	"5_Bovine_MI_2_ACAGTG.fasta",
	"6_Bovine_MII_a1_GCCAAT.fasta",
	"7_Bovine_MII_a2_CCGTCC.fasta",
	"8_Bovine_MII_b1_GTAGAG.fasta",
	"9_Bovine_MII_b2_GATCAG.fasta",
	"10_Porcine_MII_1_TAGCTT.fasta",
	"11_Porcine_MII_2_GGCTAC.fasta",
	"12_Porcine_GV_1_CTTGTA.fasta",
	"13_Porcine_GV_2_AGTCAA.fasta",
	"14_Bovine_ovary_1_AGTTCC.fasta",
	"15_Bovine_ovary_2_ATGTCA.fasta",
	"16_Bovine_testis_1_CAGATC.fasta",
	"17_Bovine_testis_2_ACTTGA.fasta",
	"18_Porcine_ovary_1_GTCCGC.fasta",
	"19_Porcine_ovary_2_GTGAAA.fasta",
	"20_Porcine_testis_1_GTGGCC.fasta",
	"21_Porcine_testis_2_GTTTCG.fasta",
	"22_Macaque_ovary_1_CGTACG.fasta",
	"23_Macaque_ovary_2_GAGTGG.fasta",
	"24_Macaque_testis_1_GGTAGC.fasta",
	"25_Macaque_testis_2_TTAGGC.fasta",
	"26_Bovine-cumulus-MI-1.fasta",
	"27_Bovine-cumulus-MI-2.fasta",
	"28_bovine_cumulus_MII_1_TTAGGC.fasta",
	"29_bovine_cumulus_MII_2_TGACCA.fasta",
	"30_porcine_cumulus_GV_1_ACAGTG.fasta",
	"31_porcine_cumulus_GV_2_GCCAAT.fasta",
	"32_porcine_GV_1_CAGATC.fasta",
	"33_porcine_GV_2_ACTTGA.fasta",
	"34_bovine_oxidized_1_GATCAG.fasta",
	"35_bovine_oxidized_2_TAGCTT.fasta",
	"36_macaque_oxidized_1_GGCTAC.fasta",
	"37_macaque_oxidized_2_CTTGTA.fasta",
	"38_bovine_IVF_1_AGTCAA.fasta",
	"39_bovine_IVF_2_AGTTCC.fasta",
	"40_human_ovary_1_ATGTCA.fasta",
	"41_human_ovary_2_CCGTCC.fasta",
	"42_human_ovary_1_oxidized_GTAGAG.fasta",
	"43_human_ovary_2_oxidized_GTCCGC.fasta",
	"44_fetal_1st_1_GTGAAA.fasta",
	"45_fetal_1st_2_GTGGCC.fasta",
	"46_fetal_1st_1_oxidized_GTTTCG.fasta",
	"47_fetal_1st_2_oxidized_CGTACG.fasta",
	"48_fetal_2nd_1_GAGTGG.fasta",
	"49_fetal_2nd_2_GGTAGC.fasta",
	"50_fetal_2nd_1_oxidized_ATCACG.fasta",
	"51_fetal_2nd_2_oxidized_CGATGT.fasta"
	);



$|=1;
foreach$input(@input)
	{
	$check_e=$input;
	$check_e=~s/\.fasta/\.clip/;
	if(-e"$check_e")
		{
		next;
		}
	unless(open(IN,$input))
		{
		print"$!: $input\n";
		}
	else
		{
		$t0=time;
		print"$input\n";
		
		$outfile1=$input;
		$outfile1=~s/\..+$/.clip/||die print"$!";
		$outfile2a=$input;
		$outfile2a=~s/\..+$/.N3/||die print"$!";
		$outfile2b=$input;
		$outfile2b=~s/\..+$/.N5/||die print"$!";
		$outfile2c=$input;
		$outfile2c=~s/\..+$/.N5-N3/||die print"$!";

		open(OUT1,">$outfile1")||die print"$!: $outfile1\n";
		open(OUT2A,">$outfile2a")||die print"$!: $outfile2a\n";
		open(OUT2B,">$outfile2b")||die print"$!: $outfile2b\n";
		open(OUT2C,">$outfile2c")||die print"$!: $outfile2b\n";
		
		$seq_count=0;
		$passed=0;
		while(<IN>)
			{
			chomp$_;
			if($_=~/^>/)
				{
				$seq_count++;
				}
			else
				{
				$search_seq=$adapter;
				$seq=$_;
				while(1)
					{
					if($seq=~s/$search_seq.*$//)
						{
						if($seq=~s/.{4}$//)
							{
							$N3=$&;
							if($seq=~s/^.{4}//)
								{
								$N5=$&;
								if(length$seq>=$min_sequence_length)
									{
									$passed++;
									$reads{$seq}{$N5}{$N3}++;
									$N5{$N5}++;
									$N3{$N3}++;
									$N5N3{"$N5-seq-$N3"}++;
									}
								}
							}
						last;
						}
					elsif(length$search_seq<=$min_adapter_length)
						{
						last;
						}
					else
						{
						$search_seq=~s/.$//;
						}
					}
				}
			}
		close IN;
		$t1=time;
		$time_used=$t1-$t0;
		
		print"Processed sequences: $seq_count\nRemaining sequences: $passed\nTime used: $time_used sec.\n\n";
		
		# print sequence fasta file: >5'-NNNN NNNN-3' number of reads with these NNNN
		for$key1(keys%reads)
			{
			for$key2(keys%{$reads{$key1}})
				{
				for$key3(keys%{$reads{$key1}{$key2}})
					{
					print OUT1">5'-$key2 $key3-3' count:$reads{$key1}{$key2}{$key3}\n$key1\n";
					}
				}
			}
		close OUT1;
		
		@N=keys%N3;
		@N=sort@N;
		foreach(@N)
			{
			print OUT2A"$_\t$N3{$_}\n";
			}
		close OUT2A;
		
		@N=keys%N5;
		@N=sort@N;
		foreach(@N)
			{
			print OUT2B"$_\t$N5{$_}\n";
			}
		close OUT2B;
		
		@N=keys%N5N3;
		@N=sort@N;
		foreach(@N)
			{
			print OUT2C"5'-$_-3'\t$N5N3{$_}\n";
			}
		close OUT2C;
		
		undef%N3;
		undef%N5;
		undef%N5N3;
		undef%reads;
		}
	}