$min_period_size=1;	# min size of repeat motif
$max_period_size=4;	# max size of repeat motif
$threshold=0.75;		# amount of read occupied by motif

@in=
	(
	"1_Bovine_GV_a_ATCACG.clip_18-34_nr",
	"2_Bovine_GV_b1_CGATGT.clip_18-34_nr",
	"4_Bovine_MI_1_TGACCA.clip_18-34_nr",
	"5_Bovine_MI_2_ACAGTG.clip_18-34_nr",
	"6_Bovine_MII_a1_GCCAAT.clip_18-34_nr",
	"7_Bovine_MII_a2_CCGTCC.clip_18-34_nr",
	"8_Bovine_MII_b1_GTAGAG.clip_18-34_nr",
	"9_Bovine_MII_b2_GATCAG.clip_18-34_nr",
	"10_Porcine_MII_1_TAGCTT.clip_18-34_nr",
	"11_Porcine_MII_2_GGCTAC.clip_18-34_nr",
	"12_Porcine_GV_1_CTTGTA.clip_18-34_nr",
	"13_Porcine_GV_2_AGTCAA.clip_18-34_nr",
	"14_Bovine_ovary_1_AGTTCC.clip_18-34_nr",
	"15_Bovine_ovary_2_ATGTCA.clip_18-34_nr",
	"16_Bovine_testis_1_CAGATC.clip_18-34_nr",
	"17_Bovine_testis_2_ACTTGA.clip_18-34_nr",
	"18_Porcine_ovary_1_GTCCGC.clip_18-34_nr",
	"19_Porcine_ovary_2_GTGAAA.clip_18-34_nr",
	"20_Porcine_testis_1_GTGGCC.clip_18-34_nr",
	"21_Porcine_testis_2_GTTTCG.clip_18-34_nr",
	"22_Macaque_ovary_1_CGTACG.clip_18-34_nr",
	"23_Macaque_ovary_2_GAGTGG.clip_18-34_nr",
	"24_Macaque_testis_1_GGTAGC.clip_18-34_nr",
	"25_Macaque_testis_2_TTAGGC.clip_18-34_nr",
	"26_Bovine-cumulus-MI-1.clip_18-34_nr",
	"27_Bovine-cumulus-MI-2.clip_18-34_nr",
	"28_bovine_cumulus_MII_1_TTAGGC.clip_18-34_nr",
	"29_bovine_cumulus_MII_2_TGACCA.clip_18-34_nr",
	"30_porcine_cumulus_GV_1_ACAGTG.clip_18-34_nr",
	"31_porcine_cumulus_GV_2_GCCAAT.clip_18-34_nr",
	"32_porcine_GV_1_CAGATC.clip_18-34_nr",
	"33_porcine_GV_2_ACTTGA.clip_18-34_nr",
	"34_bovine_oxidized_1_GATCAG.clip_18-34_nr",
	"35_bovine_oxidized_2_TAGCTT.clip_18-34_nr",
	"36_macaque_oxidized_1_GGCTAC.clip_18-34_nr",
	"37_macaque_oxidized_2_CTTGTA.clip_18-34_nr",
	"38_bovine_IVF_1_AGTCAA.clip_18-34_nr",
	"39_bovine_IVF_2_AGTTCC.clip_18-34_nr",
	"40_human_ovary_1_ATGTCA.clip_18-34_nr",
	"41_human_ovary_2_CCGTCC.clip_18-34_nr",
	"42_human_ovary_1_oxidized_GTAGAG.clip_18-34_nr",
	"43_human_ovary_2_oxidized_GTCCGC.clip_18-34_nr",
	"44_fetal_1st_1_GTGAAA.clip_18-34_nr",
	"45_fetal_1st_2_GTGGCC.clip_18-34_nr",
	"46_fetal_1st_1_oxidized_GTTTCG.clip_18-34_nr",
	"47_fetal_1st_2_oxidized_CGTACG.clip_18-34_nr",
	"48_fetal_2nd_1_GAGTGG.clip_18-34_nr",
	"49_fetal_2nd_2_GGTAGC.clip_18-34_nr",
	"50_fetal_2nd_1_oxidized_ATCACG.clip_18-34_nr",
	"51_fetal_2nd_2_oxidized_CGATGT.clip_18-34_nr"
	);

$|=1;
foreach$file(@in)
	{
	print"\n$file";
	
	$out=$file."_ns";
	$junk=$file;
	$junk=~s/\.clip_18-34_nr$/.simple/||die print$!;
	
	open(IN,$file);
	open(OUT,">$out")||die print$!;
	open(SIMPLE,">$junk")||die print$!;
	while(<IN>)
		{
		chomp$_;
		if($_=~/^>/)
			{
			$title=$_;
			}
		else
			{
			$ok=1;
			$read_length=length$_;
			%fragments=();
			foreach$frag_size($min_period_size..$max_period_size)
				{
				$gnaw=$_;
				while(length$gnaw>=$frag_size)
					{
					$gnaw=~s/^.{$frag_size}//;
					$fragments{$&}=1;
					}
				}
			foreach$fragment(keys%fragments)
				{
				$check=$_;
				$check=~s/$fragment//g;
				if(length$check<=$read_length*(1-$threshold))
					{
					$ok=0;
					last;
					}
				}
			undef%fragments;
			if($ok==1)
				{
				print OUT"$title\n$_\n";
				}
			else
				{
				print SIMPLE"$title\n$_\n";
				#print"$title\n$_\n";
				}
			}
		}
	close IN;
	close OUT;
	close SIMPLE;
	}